--
-- Tabella delle tranzazioni web
--
CREATE TABLE webs (
  id INT( 10 ) NOT NULL AUTO_INCREMENT,
  sol_id INT( 10 ) NOT NULL REFERENCES sols(id) ON DELETE CASCADE,
  pol_id INT( 10 ) NOT NULL REFERENCES pols(id) ON DELETE CASCADE,
  source_id INT( 10 ) NOT NULL REFERENCES sources(id) ON DELETE CASCADE,
  web_id INT( 10 ) DEFAULT -1,
  capture_date TIMESTAMP NOT NULL DEFAULT '0000-00-00 00:00:00',
  decoding_date TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP,
  viewed_date TIMESTAMP NOT NULL DEFAULT '0000-00-00 00:00:00',
  first_visualization_user_id INT( 10 ) COMMENT 'Id utente',
  flow_info VARCHAR( 255 ) NOT NULL COMMENT 'Xml file of flow',
  url VARCHAR( 4096 ),
  relation ENUM ('POSSIBLY_CONTAINER', 'POSSIBLY_CONTAINED', 'CONTAINER', 'CONTAINED', 'SERVICES', 'NONE') NOT NULL DEFAULT 'NONE',
  method VARCHAR( 10 ) NOT NULL,
  response VARCHAR( 5 ) NOT NULL,
  host VARCHAR( 255 ) NOT NULL,
  content_type VARCHAR( 255 ) NOT NULL,
  rq_header VARCHAR( 255 ) COMMENT 'percorso del file',
  rq_body VARCHAR( 255 ) COMMENT 'percorso del file',
  rq_bd_size INT( 30 ),
  rs_header VARCHAR( 255 ) COMMENT 'percorso del file',
  rs_body VARCHAR( 255 ) COMMENT 'percorso del file',
  rs_bd_size INT( 30 ),
  PRIMARY KEY (id)
) TYPE = MYISAM ;