<?php
  /* ***** BEGIN LICENSE BLOCK *****
   * Version: MPL 1.1/GPL 2.0/LGPL 2.1
   *
   * The contents of this file are subject to the Mozilla Public License
   * Version 1.1 (the "MPL"); you may not use this file except in
   * compliance with the MPL. You may obtain a copy of the MPL at
   * http://www.mozilla.org/MPL/
   *
   * Software distributed under the MPL is distributed on an "AS IS" basis,
   * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the MPL
   * for the specific language governing rights and limitations under the
   * MPL.
   *
   * The Original Code is Xplico Interface (XI).
   *
   * The Initial Developer of the Original Code is
   * Gianluca Costa <g.costa@xplico.org>
   * Portions created by the Initial Developer are Copyright (C) 2007
   * the Initial Developer. All Rights Reserved.
   *
   * Contributor(s):
   *
   * Alternatively, the contents of this file may be used under the terms of
   * either the GNU General Public License Version 2 or later (the "GPL"), or
   * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
   * in which case the provisions of the GPL or the LGPL are applicable instead
   * of those above. If you wish to allow use of your version of this file only
   * under the terms of either the GPL or the LGPL, and not to allow others to
   * use your version of this file under the terms of the MPL, indicate your
   * decision by deleting the provisions above and replace them with the notice
   * and other provisions required by the GPL or the LGPL. If you do not delete
   * the provisions above, a recipient may use your version of this file under
   * the terms of any one of the MPL, the GPL or the LGPL.
   *
   * ***** END LICENSE BLOCK ***** */

class XplicoComponent extends Object
{
    var $controller = true;
    var $Session;

    function startup(&$controller) {
        // This method takes a reference to the controller which is loading it.
        // Perform controller initialization here.
        $this->Session = $controller->Session;
    }
    
    function leftmenuarray($open) {
        $solid = $this->Session->read('sol');
        $menu_left = array('active' => $open, 'sections' => array(
                               array('name' => 'Case', 'sub' => array(
                                         array('name' => 'Cases', 'link' => '/pols'),
                                         array('name' => 'Sessions', 'link' => '/sols/index'),
                                         array('name' => 'Session', 'link' => '/sols/view/'.$solid)
                                         )
                                   ),
                               array('name' => 'Graphs', 'sub' => array(
                                         array('name' => 'Dns', 'link' => '/dns_messages/index'),
                                         array('name' => 'GeoMap', 'link' => '/inputs/geomap')
                                         )
                                   ),
                               array('name' => 'Web', 'sub' => array(
                                         array('name' => 'Site', 'link' => '/webs/index'),
                                         array('name' => 'Feed', 'link' => '/feeds/index'),
                                         array('name' => 'Images', 'link' => '/webs/images')
                                         )
                                   ),
                               array('name' => 'Mail', 'sub' => array(
                                         array('name' => 'Email', 'link' => '/emails/index'),
                                         array('name' => 'Yahoo Web', 'link' => '/webmails/yahoo'),
                                         array('name' => 'Live Web', 'link' => '/webmails/live'),
                                         array('name' => 'AOL Web', 'link' => '/webmails/aol')
                                         )
                                   ),
                               array('name' => 'Voip', 'sub' => array(
                                         array('name' => 'Sip', 'link' => '/sips/index'),
                                         array('name' => 'Rtp', 'link' => '/rtps/index')
                                         )
                                   ),
                               array('name' => 'Share', 'sub' => array(
                                         array('name' => 'HttpFile', 'link' => '/httpfiles/index'),
                                         array('name' => 'Ftp', 'link' => '/ftps/index'),
                                         array('name' => 'Tftp', 'link' => '/tftps/index'),
                                         array('name' => 'Printer', 'link' => '/pjls/index'),
                                         array('name' => 'Mms', 'link' => '/mms/index')
                                         )
                                   ),
                               array('name' => 'Chat', 'sub' => array(
                                         array('name' => 'Nntp', 'link' => '/nntp_groups/index'),
                                         array('name' => 'Facebook', 'link' => '/fbuchats/index')
                                         )
                                   ),
                               array('name' => 'Shell', 'sub' => array(
                                         array('name' => 'Telnet', 'link' => '/telnets/index')
                                         )
                                   ),
                               array('name' => 'Undecod', 'sub' => array(
                                         array('name' => 'TCP-UDP', 'link' => '/unknows/index')
                                         )
                                   )
                               )
            );
        return $menu_left;        
    }

    function checkXplicoStatus(){
        //Check for Xplico process status ("dema"). 0=not running; 1=running.
         $isXplicoRunning = 0;

        if (file_exists ('/var/run/dema.pid')) {
              $foca = fopen('/var/run/dema.pid', 'r');
              if ($foca) {
                  $dema_pid = fgets($foca, 200);
                  fclose($foca);
                  $foca = popen('ps -p '.$dema_pid.' | grep dema', 'r');
                  if ($foca) {
                      while (!feof($foca)) {
                          $dema_pid = fgets($foca, 200);
                          if (strstr($dema_pid, 'dema'))
                              $isXplicoRunning = 1;
                      }
                      pclose($foca);
                  }
              }
            }
        return $isXplicoRunning;
        }


}
?>